/*****************************
* Source : pcre_base.prg           
* System : <unkown>           
* Author : Phil Ide           
* Created: 30/05/2003             
*                             
* Purpose:                    
* ----------------------------
* History:                    
* ----------------------------
*    30/05/2003 10:09 PPI - Created                
*****************************/
                              
#include "common.ch"
#include "dll.ch"

CLASS pcre_base
   PROTECTED:
      CLASS VAR xbpcre
      CLASS VAR cCompTemp
      CLASS VAR cStudyTemp
      CLASS VAR cExecTemp        // evg 5/23/2003
      CLASS VAR cRegFreeTemp
      CLASS VAR cFullInfoTemp

      METHOD pcre_compile
      METHOD pcre_study
      METHOD pcre_exec
      METHOD pcre_fullinfo
      METHOD regfree
      METHOD init
ENDCLASS

METHOD pcre_base:init()
   if ::xbpcre == Nil
      ::xbpcre          := DllLoad('pcre.dll')
      ::cCompTemp       := DllPrepareCall(::xbpcre,DLL_CDECL,'pcre_compile')
      ::cStudyTemp      := DllPrepareCall(::xbpcre,DLL_CDECL,'pcre_study')
      ::cExecTemp       := DllPrepareCall(::xbpcre,DLL_CDECL,'pcre_exec')
      ::cRegFreeTemp    := DllPrepareCall(::xbpcre,DLL_CDECL,'regfree')
      ::cFullInfoTemp   := DllPrepareCall(::xbpcre,DLL_CDECL,'pcre_fullinfo')
   endif
   return self

METHOD pcre_base:pcre_compile(cExpr, nOpts, cErrMsg, nErrOffset, cTblPtr )
   return DLLExecuteCall(::cCompTemp,cExpr, nOpts, @cErrMsg, @nErrOffset, cTblPtr )

METHOD pcre_base:pcre_study(ePattern, nOpts, cErrMsg)
   return DLLExecuteCall(::cStudyTemp, ePattern, nOpts, @cErrMsg)

METHOD pcre_base:pcre_exec(ePattern, xStudy, cSubj, nSubjLen, nStrtOff, nOpts, cBin, naVectLen )
   return DLLExecuteCall(::cExecTemp,ePattern, xStudy, cSubj, nSubjLen, nStrtOff, nOpts, @cBin, naVectLen )

METHOD pcre_base:pcre_fullinfo(ePattern, extra_block, nOpt, nInt )
   return DLLExecuteCall(::cExecTemp, ePattern, extra_block, nOpt, @nInt )

METHOD pcre_base:regfree(p)
   return DLLExecuteCall(::cRegFreeTemp, @p)

